Package icyllis.modernui.graphics

# Class RectF

java.lang.Object
icyllis.modernui.graphics.RectF

public class RectF extends Object
Represents a rectangle holding four float coordinates.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `float`
  `bottom`
  `float`
  `left`
  `float`
  `right`
  `float`
  `top`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RectF()`
  Create a new empty RectF.
  `RectF(float left, float top, float right, float bottom)`
  Create a new rectangle with the specified coordinates.
  `RectF(Rect r)`
  `RectF(RectF r)`
  Create a new rectangle, initialized with the values in the specified rectangle (which is left unmodified).

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final float`
  `centerX()`
  `final float`
  `centerY()`
  `boolean`
  `contains(float x, float y)`
  Returns true if (x,y) is inside the rectangle.
  `boolean`
  `contains(float left, float top, float right, float bottom)`
  Returns true if the 4 specified sides of a rectangle are inside or equal to this rectangle.
  `boolean`
  `contains(RectF r)`
  Returns true if the specified rectangle r is inside or equal to this rectangle.
  `RectF`
  `copy()`
  `static RectF`
  `copy(RectF r)`
  Returns a copy of `r` if it is not `null`, or an empty Rect otherwise.
  `boolean`
  `equals(Object o)`
  `int`
  `hashCode()`
  `final float`
  `height()`
  `void`
  `inset(float dx, float dy)`
  Inset the rectangle by (dx,dy).
  `boolean`
  `intersect(float left, float top, float right, float bottom)`
  If the rectangle specified by left,top,right,bottom intersects this rectangle, return true and set this rectangle to that intersection, otherwise return false and do not change this rectangle.
  `boolean`
  `intersect(RectF r)`
  If the specified rectangle intersects this rectangle, return true and set this rectangle to that intersection, otherwise return false and do not change this rectangle.
  `boolean`
  `intersects(float left, float top, float right, float bottom)`
  Returns true if this rectangle intersects the specified rectangle.
  `static boolean`
  `intersects(RectF a, RectF b)`
  Returns true if the two specified rectangles intersect.
  `final boolean`
  `isEmpty()`
  Returns true if left is equal to or greater than right, or if top is equal to or greater than bottom.
  `final boolean`
  `isFinite()`
  Returns true if all values in the rectangle are finite.
  `final boolean`
  `isSorted()`
  Returns true if left is equal to or less than right, or if top is equal to or less than bottom.
  `void`
  `offset(float dx, float dy)`
  Offset the rectangle by adding dx to its left and right coordinates, and adding dy to its top and bottom coordinates.
  `void`
  `offsetTo(float newLeft, float newTop)`
  Offset the rectangle to a specific (left, top) position, keeping its width and height the same.
  `void`
  `round(Rect dst)`
  Set the dst integer Rect by rounding this rectangle's coordinates to their nearest integer values.
  `void`
  `roundOut(Rect dst)`
  Set the dst integer Rect by rounding "out" this rectangle, choosing the floor of top and left, and the ceiling of right and bottom.
  `void`
  `set(float left, float top, float right, float bottom)`
  Set the rectangle's coordinates to the specified values.
  `void`
  `set(Rect src)`
  Copy the coordinates from src into this rectangle.
  `void`
  `set(RectF src)`
  Copy the coordinates from src into this rectangle.
  `void`
  `setEmpty()`
  Set the rectangle to (0,0,0,0)
  `boolean`
  `setIntersect(RectF a, RectF b)`
  If rectangles a and b intersect, return true and set this rectangle to that intersection, otherwise return false and do not change this rectangle.
  `void`
  `sort()`
  Swap top/bottom or left/right if there are flipped (i.e.
  `String`
  `toString()`
  `void`
  `transform(Matrix m)`
  Transform this rectangle in place using the supplied Matrix m.
  `void`
  `union(float x, float y)`
  Update this Rect to enclose itself and the [x,y] coordinate.
  `void`
  `union(float left, float top, float right, float bottom)`
  Update this Rect to enclose itself and the specified rectangle.
  `void`
  `union(RectF r)`
  Update this Rect to enclose itself and the specified rectangle.
  `final float`
  `width()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### left

    public float left

  - ### top

    public float top

  - ### right

    public float right

  - ### bottom

    public float bottom

- ## Constructor Details

  - ### RectF

    public RectF()
    Create a new empty RectF. All coordinates are initialized to 0.

  - ### RectF

    public RectF(float left, float top, float right, float bottom)
    Create a new rectangle with the specified coordinates. Note: no range checking is performed, so the caller must ensure that left invalid input: '<'= right and top invalid input: '<'= bottom.
    Parameters:
      `left` - The X coordinate of the left side of the rectangle
      `top` - The Y coordinate of the top of the rectangle
      `right` - The X coordinate of the right side of the rectangle
      `bottom` - The Y coordinate of the bottom of the rectangle

  - ### RectF

    public RectF(@Nullable RectF r)
    Create a new rectangle, initialized with the values in the specified rectangle (which is left unmodified).
    Parameters:
      `r` - The rectangle whose coordinates are copied into the new rectangle.

  - ### RectF

    public RectF(@Nullable Rect r)

- ## Method Details

  - ### copy

    @NonNull public static RectF copy(@Nullable RectF r)
    Returns a copy of `r` if it is not `null`, or an empty Rect otherwise.
    Parameters:
      `r` - the rect to copy from

  - ### isEmpty

    public final boolean isEmpty()
    Returns true if left is equal to or greater than right, or if top is equal to or greater than bottom. Call sort() to reverse rectangles with negative width() or height().
    Returns:
      true if width() or height() are zero or negative

  - ### isSorted

    public final boolean isSorted()
    Returns true if left is equal to or less than right, or if top is equal to or less than bottom. Call sort() to reverse rectangles with negative width() or height().
    Returns:
      true if width() or height() are zero or positive

  - ### isFinite

    public final boolean isFinite()
    Returns true if all values in the rectangle are finite.
    Returns:
      true if no member is infinite or NaN

  - ### width

    public final float width()
    Returns:
      the rectangle's width. This does not check for a valid rectangle (i.e. left invalid input: '<'= right) so the result may be negative.

  - ### height

    public final float height()
    Returns:
      the rectangle's height. This does not check for a valid rectangle (i.e. top invalid input: '<'= bottom) so the result may be negative.

  - ### centerX

    public final float centerX()
    Returns:
      the horizontal center of the rectangle. This does not check for a valid rectangle (i.e. left invalid input: '<'= right)

  - ### centerY

    public final float centerY()
    Returns:
      the vertical center of the rectangle. This does not check for a valid rectangle (i.e. top invalid input: '<'= bottom)

  - ### setEmpty

    public void setEmpty()
    Set the rectangle to (0,0,0,0)

  - ### set

    public void set(float left, float top, float right, float bottom)
    Set the rectangle's coordinates to the specified values. Note: no range checking is performed, so it is up to the caller to ensure that left invalid input: '<'= right and top invalid input: '<'= bottom.
    Parameters:
      `left` - The X coordinate of the left side of the rectangle
      `top` - The Y coordinate of the top of the rectangle
      `right` - The X coordinate of the right side of the rectangle
      `bottom` - The Y coordinate of the bottom of the rectangle

  - ### set

    public void set(@NonNull RectF src)
    Copy the coordinates from src into this rectangle.
    Parameters:
      `src` - The rectangle whose coordinates are copied into this rectangle.

  - ### set

    public void set(@NonNull Rect src)
    Copy the coordinates from src into this rectangle.
    Parameters:
      `src` - The rectangle whose coordinates are copied into this rectangle.

  - ### offset

    public void offset(float dx, float dy)
    Offset the rectangle by adding dx to its left and right coordinates, and adding dy to its top and bottom coordinates.
    Parameters:
      `dx` - The amount to add to the rectangle's left and right coordinates
      `dy` - The amount to add to the rectangle's top and bottom coordinates

  - ### offsetTo

    public void offsetTo(float newLeft, float newTop)
    Offset the rectangle to a specific (left, top) position, keeping its width and height the same.
    Parameters:
      `newLeft` - The new "left" coordinate for the rectangle
      `newTop` - The new "top" coordinate for the rectangle

  - ### inset

    public void inset(float dx, float dy)
    Inset the rectangle by (dx,dy). If dx is positive, then the sides are moved inwards, making the rectangle narrower. If dx is negative, then the sides are moved outwards, making the rectangle wider. The same holds true for dy and the top and bottom.
    Parameters:
      `dx` - The amount to add(subtract) from the rectangle's left(right)
      `dy` - The amount to add(subtract) from the rectangle's top(bottom)

  - ### contains

    public boolean contains(float x, float y)
    Returns true if (x,y) is inside the rectangle. The left and top are considered to be inside, while the right and bottom are not. This means that for a (x,y) to be contained: left invalid input: '<'= x invalid input: '<' right and top invalid input: '<'= y invalid input: '<' bottom. An empty rectangle never contains any point.
    Parameters:
      `x` - The X coordinate of the point being tested for containment
      `y` - The Y coordinate of the point being tested for containment
    Returns:
      true if (x,y) are contained by the rectangle, where containment means left invalid input: '<'= x invalid input: '<' right and top invalid input: '<'= y invalid input: '<' bottom

  - ### contains

    public boolean contains(float left, float top, float right, float bottom)
    Returns true if the 4 specified sides of a rectangle are inside or equal to this rectangle. i.e. is this rectangle a superset of the specified rectangle. An empty rectangle never contains another rectangle.
    Parameters:
      `left` - The left side of the rectangle being tested for containment
      `top` - The top of the rectangle being tested for containment
      `right` - The right side of the rectangle being tested for containment
      `bottom` - The bottom of the rectangle being tested for containment
    Returns:
      true if the 4 specified sides of a rectangle are inside or equal to this rectangle

  - ### contains

    public boolean contains(@NonNull RectF r)
    Returns true if the specified rectangle r is inside or equal to this rectangle. An empty rectangle never contains another rectangle.
    Parameters:
      `r` - The rectangle being tested for containment.
    Returns:
      true if the specified rectangle r is inside or equal to this rectangle

  - ### intersect

    public boolean intersect(float left, float top, float right, float bottom)
    If the rectangle specified by left,top,right,bottom intersects this rectangle, return true and set this rectangle to that intersection, otherwise return false and do not change this rectangle. No check is performed to see if either rectangle is empty. Note: To just test for intersection, use intersects()
    Parameters:
      `left` - The left side of the rectangle being intersected with this rectangle
      `top` - The top of the rectangle being intersected with this rectangle
      `right` - The right side of the rectangle being intersected with this rectangle.
      `bottom` - The bottom of the rectangle being intersected with this rectangle.
    Returns:
      true if the specified rectangle and this rectangle intersect (and this rectangle is then set to that intersection) else return false and do not change this rectangle.

  - ### intersect

    public boolean intersect(@NonNull RectF r)
    If the specified rectangle intersects this rectangle, return true and set this rectangle to that intersection, otherwise return false and do not change this rectangle. No check is performed to see if either rectangle is empty. To just test for intersection, use intersects()
    Parameters:
      `r` - The rectangle being intersected with this rectangle.
    Returns:
      true if the specified rectangle and this rectangle intersect (and this rectangle is then set to that intersection) else return false and do not change this rectangle.

  - ### setIntersect

    public boolean setIntersect(@NonNull RectF a, @NonNull RectF b)
    If rectangles a and b intersect, return true and set this rectangle to that intersection, otherwise return false and do not change this rectangle. No check is performed to see if either rectangle is empty. To just test for intersection, use intersects()
    Parameters:
      `a` - The first rectangle being intersected with
      `b` - The second rectangle being intersected with
    Returns:
      true if the two specified rectangles intersect. If they do, set this rectangle to that intersection. If they do not, return false and do not change this rectangle.

  - ### intersects

    public boolean intersects(float left, float top, float right, float bottom)
    Returns true if this rectangle intersects the specified rectangle. In no event is this rectangle modified. No check is performed to see if either rectangle is empty. To record the intersection, use intersect() or setIntersect().
    Parameters:
      `left` - The left side of the rectangle being tested for intersection
      `top` - The top of the rectangle being tested for intersection
      `right` - The right side of the rectangle being tested for intersection
      `bottom` - The bottom of the rectangle being tested for intersection
    Returns:
      true if the specified rectangle intersects this rectangle. In no event is this rectangle modified.

  - ### intersects

    public static boolean intersects(@NonNull RectF a, @NonNull RectF b)
    Returns true if the two specified rectangles intersect. In no event are either of the rectangles modified. To record the intersection, use intersect() or setIntersect().
    Parameters:
      `a` - The first rectangle being tested for intersection
      `b` - The second rectangle being tested for intersection
    Returns:
      true if the two specified rectangles intersect. In no event are either of the rectangles modified.

  - ### round

    public void round(@NonNull Rect dst)
    Set the dst integer Rect by rounding this rectangle's coordinates to their nearest integer values.

  - ### roundOut

    public void roundOut(@NonNull Rect dst)
    Set the dst integer Rect by rounding "out" this rectangle, choosing the floor of top and left, and the ceiling of right and bottom.

  - ### union

    public void union(float left, float top, float right, float bottom)
    Update this Rect to enclose itself and the specified rectangle. If the specified rectangle is empty, nothing is done. If this rectangle is empty it is set to the specified rectangle.
    Parameters:
      `left` - The left edge being unioned with this rectangle
      `top` - The top edge being unioned with this rectangle
      `right` - The right edge being unioned with this rectangle
      `bottom` - The bottom edge being unioned with this rectangle

  - ### union

    public void union(@NonNull RectF r)
    Update this Rect to enclose itself and the specified rectangle. If the specified rectangle is empty, nothing is done. If this rectangle is empty it is set to the specified rectangle.
    Parameters:
      `r` - The rectangle being unioned with this rectangle

  - ### union

    public void union(float x, float y)
    Update this Rect to enclose itself and the [x,y] coordinate. There is no check to see that this rectangle is non-empty.
    Parameters:
      `x` - The x coordinate of the point to add to the rectangle
      `y` - The y coordinate of the point to add to the rectangle

  - ### sort

    public void sort()
    Swap top/bottom or left/right if there are flipped (i.e. left > right and/or top > bottom). This can be called if the edges are computed separately, and may have crossed over each other. If the edges are already correct (i.e. left invalid input: '<'= right and top invalid input: '<'= bottom) then nothing is done.

  - ### transform

    public void transform(@NonNull Matrix m)
    Transform this rectangle in place using the supplied Matrix m.

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### copy

    @NonNull public RectF copy()